DELETE FROM
  steps
WHERE
  rowid IN (
    SELECT
      a.rowid
    FROM
      steps a
    WHERE
      EXISTS (
        SELECT
          b.rowid
        FROM
          steps b
        WHERE
          a.rowid > b.rowid
          AND a.watch_serial = b.watch_serial
          AND a.date = b.date
      )
  );

CREATE UNIQUE INDEX IF NOT EXISTS steps_unique_index ON steps (watch_serial, date);

DELETE FROM
  activity_sessions
WHERE
  rowid IN (
    SELECT
      a.rowid
    FROM
      activity_sessions a
    WHERE
      EXISTS (
        SELECT
          b.rowid
        FROM
          activity_sessions b
        WHERE
          a.rowid > b.rowid
          AND a.watch_serial = b.watch_serial
          AND a.activity_type = b.activity_type
          AND a.start_time = b.start_time
      )
  );

CREATE UNIQUE INDEX IF NOT EXISTS activity_sessions_unique_index ON activity_sessions (
  watch_serial, activity_type, start_time
);
