ALTER TABLE
  `activity_sessions` RENAME TO `activity_sessions_old`; CREATE TABLE `activity_sessions` (
    `id` INTEGER PRIMARY KEY AUTOINCREMENT,
    `watch_serial` TEXT NOT NULL, `activity_type` INTEGER NOT NULL,
    `start_time` INTEGER NOT NULL, `end_time` INTEGER NOT NULL,
    `tz_offset` INTEGER NOT NULL DEFAULT 0,
    `active_calories` INTEGER NOT NULL DEFAULT 0,
    `step_count` INTEGER NOT NULL DEFAULT 0,
    `calories` INTEGER NOT NULL DEFAULT 0,
    `distance` INTEGER NOT NULL DEFAULT 0,
    `start_date_tz` INTEGER NOT NULL,
    `end_date_tz` INTEGER NOT NULL
  ); INSERT INTO `activity_sessions`

SELECT
  NULL,
  *
FROM
  `activity_sessions_old`;

DROP
  TABLE `activity_sessions_old`;

UPDATE
  `steps`
SET
  `active_calories` = 0
WHERE
  `active_calories` IS NULL;

ALTER TABLE
  `steps` RENAME TO `steps_old`;

CREATE TABLE `steps` (
  `id` INTEGER PRIMARY KEY AUTOINCREMENT,
  `watch_serial` TEXT NOT NULL, `step_count` INTEGER NOT NULL DEFAULT 0,
  `date` INTEGER NOT NULL, `orientation` INTEGER NOT NULL DEFAULT 0,
  `vmc` INTEGER NOT NULL DEFAULT 0, `light` INTEGER NOT NULL DEFAULT 0,
  `plugged_in` INTEGER NOT NULL DEFAULT 0,
  `distance` INTEGER NOT NULL DEFAULT 0,
  `calories` INTEGER NOT NULL DEFAULT 0,
  `time_active` INTEGER NOT NULL DEFAULT 0,
  `active_calories` INTEGER NOT NULL DEFAULT 0,
  `tz_offset` INTEGER NOT NULL DEFAULT 0,
  `date_tz` INTEGER NOT NULL
);

INSERT INTO `steps`
  SELECT
    NULL,
    *
  FROM
    `steps_old`;

DROP
  TABLE `steps_old`;

CREATE TABLE `watches` (
  `serial_number` TEXT PRIMARY KEY, `steps_cursor` INTEGER DEFAULT 0,
  `activity_sessions_cursor` INTEGER DEFAULT 0
);

CREATE INDEX IF NOT EXISTS `date_tz_index` ON `steps` (date_tz);

CREATE UNIQUE INDEX IF NOT EXISTS steps_unique_index ON steps (watch_serial, date);
CREATE INDEX IF NOT EXISTS `end_date_tz_index` ON `activity_sessions` (end_date_tz);
CREATE UNIQUE INDEX IF NOT EXISTS activity_sessions_unique_index ON activity_sessions (
  watch_serial, activity_type, start_time
);

REINDEX;

INSERT INTO watches
  SELECT
    watch_serial,
    MAX(steps_counter),
    MAX(activity_sessions_counter)
  FROM
    (
      SELECT
        s.watch_serial,
        MAX(s.id) AS steps_counter,
        NULL as activity_sessions_counter
      FROM
        steps s
      GROUP BY
        s.watch_serial
      UNION
      SELECT
        a.watch_serial,
        NULL AS steps_counter,
        MAX(a.id) AS activity_sessions_counter
      FROM
        activity_sessions a
      GROUP BY
        a.watch_serial
    )
  GROUP BY
    watch_serial;
